#define nexSer Serial1  // Controlling the Nextion HMI using Serial1 (pin18 of the Arduino Mega) to prevent interfering with code upload
#define dbgSer Serial   // Debug using default Serial over USB towards Arduino Serial Monitor
#define DEBUG           // Comment this out if you don't need to see what happens in the Serial Monitor

// Global variables
uint32_t timTarget = 0;
uint16_t interval = 200                                                                                                                            ;
uint32_t readVal = 0;
int32_t dispVal = 0;
int32_t lastVal = 0;

void sendCmd(String cmd)
{
  nexSer.print(cmd);
  nexSer.write("\xFF\xFF\xFF");
#ifdef DEBUG
  if(cmd.length() > 0)
  {
    dbgSer.print("Sending command : ");
    dbgSer.println(cmd);
  } else
  {
    dbgSer.println("Empty command issued to clear the buffer");  
  }
#endif
}

void setup() {
  // put your setup code here, to run once:
  dbgSer.begin(9600);
  while(!dbgSer); // Wait for connect
  nexSer.begin(9600);
  while(!nexSer); // wait for connect  
  sendCmd(""); // clear the buffer

}

void loop() {
  // put your main code here, to run repeatedly:
  if(millis() >= timTarget) {
    // Interval has passed, let's execute the timed action
    timTarget = millis() + interval; // Set the next target
    readVal = analogRead(A0);
    dispVal = readVal * 5000 / 1023;
    if(dispVal != lastVal) {
      sendCmd("x0.val=" + (String)dispVal);
      lastVal = dispVal;
    }
  }
  else {
    // Do some other stuff if needed  
  } 
}
